
package NetHirc::BigBrother;

=pod

=head2 new

It's 1984 all over again!  Instantiate your own Big Brother today!

=over 4

=item Parameters

None.

=item Returns

A new instance of the class.

=back

=cut

use Carp;

my @dull_words = qw(a an and are as at to the of or on if in is it for from with by);

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {
	'Pr'		=>	11,
	'Pa'		=>	503,
	'Pd'		=>	3,
	'Pk'		=>	4,
	'limit'		=>	7,
	'toggle'	=>	1,
	'verboten'	=>	[],
	'announce'	=>	sub { },
    };
    bless $self, $class;
}

sub check {
    my ($self, $text) = @_;
    return unless $self->{'toggle'};
    my $p = int(rand($self->{'Pr'}));
    $self->revise($text) unless $p;
    my $q = int(rand($self->{'Pa'}));
    $self->announce() unless $q;
}

sub revise {
    my $self = shift;
    my $text = shift;
    my $bbv = $self->{'verboten'};
    my $Pd = $self->{'Pd'};
    my $Pk = $self->{'Pk'};
    my @pottymouth;
    my @revised;
    for my $i (@$bbv) {
	next if int(rand($Pd));
	unshift @pottymouth, $i;
    }
    my @new_words = split(' ', $text);
    unshift @pottymouth, grep { not dull_word($_) } @new_words;
    for my $j (@pottymouth) {
	next if int(rand($Pk));
	push @revised, $j;
    }
    splice @revised, $self->{'limit'};
    $self->{'verboten'} = \@revised;
}

sub announce {
    my $self = shift;
    return unless @{$self->{'verboten'}};
    return unless $self->{'announce'};
    $self->{'announce'}->($self);
}

sub verboten {
    my $self = shift;
    return @{$self->{'verboten'}};
}

sub set_announce {
    my $self = shift;
    my $code = shift;
    if (ref $code ne 'CODE') {
	croak __PACKAGE__, "::set_announce -- not a CODE ref";
    }
    $self->{'announce'} = $code;
};

sub dull_word {
    my $word = shift;
    return 1 if (length($word) == 1);
    grep { (lc($word) eq $_) || ($word =~ /^\W+$/) } @dull_words;
}

1;
