package NetHirc::State;

use strict;

use NetHirc::Formats;
use NetHirc::Helpers;

$NetHirc::State::bailmsg = "You escaped the dungeon.";
$NetHirc::State::echo = 1;
$NetHirc::State::first_connect = 1;
%NetHirc::State::first_disconnect = ();
$NetHirc::State::class = NetHirc::Helpers::pickrandom(@classes);
$NetHirc::State::deity = NetHirc::Helpers::pickrandom(@deities);
%NetHirc::State::oldnick = ();
$NetHirc::State::supported_ctcp = q(VERSION TIME PING SOURCE USERINFO CLIENTINFO FINGER);
$NetHirc::State::log = undef;
$NetHirc::State::logname = undef;
@NetHirc::State::chanlist = ();
$NetHirc::State::defchannel = undef;
%NetHirc::State::cpings = ();
$NetHirc::State::terminal = undef;
%NetHirc::State::weapons = ();
$NetHirc::State::countdb = undef;
$NetHirc::State::countdbname = "nethirc-counts";
$NetHirc::State::counting = 0;

1;

